TileFromAscii:
    pha
    lda temp5
    cmp #$02
    beq +
    pla
    rts
+
    pla
    cmp #$20 ; space
    bne +
    lda #$24
    rts
+
    cmp #$2d ; -
    bne +
    lda #$28
    rts
+
    cmp #$21 ; !
    bne +
    lda #$2b
    rts
+
    cmp #$41 ; A
    bcc +
    cmp #$5a ; Z
    bcs +
    sec
    sbc #$37
    rts
+
    cmp #$30 ; 0
    bcc +
    cmp #$39 ; 9
    bcs +
    sec
    sbc #$30
    rts
+
    rts

Printer:
        sty tempY
        stx tempX
        tax             ; store a in x for our index
        lda $00
        sta temp00
        lda $01
        sta temp01
        
;        lda #BANK_DATA
;        jsr BankSwap
        
        lda TextTable_Low,x
        sta $00
        lda TextTable_High,x
        sta $01

        lda #$02
        sta temp5                      ; initialize temp address
        
        ldy #$00                        ; Initialize y for our table index
PrinterEntryLoop:
        bit PPUSTATUS                  ; Reset address latch flip-flop
        
        lda ($00),y                     ; Read the first byte (address high byte or control byte)
        beq exPrinter                   ; If the first byte of our address is 0,
                                        ; it means end of data.
        cmp #$01
        beq PrinterSetControl
        cmp #$02
        bne PrinterSkipControl
PrinterSetControl:
        iny                             ; Increment table index
        sta temp5                      ; store control byte value in temp address
        lda ($00),y                     ; Read the next byte
PrinterSkipControl:
        sta PPUADDR                 ; Write address high byte to PPU
        iny                             ; Increment table index
        lda ($00),y                     ; Read the next byte (address low byte)
        sta PPUADDR                 ; Write address low byte to PPU

    lda #$00
    sta PPUADDR


        iny                             ; Increment table index
        lda ($00),y                     ; Read the next byte (number of bytes to write)
        tax                             ; Store length of data to write in x
        iny                             ; Increment table index
PrinterRead:
        lda ($00),y                     ; Read next byte from our table
        ;jsr TileFromAscii
        sta PPUDATA                    ; Store in PPU

        iny                             ; Increment table index
        dex                             ; Decrement number of bytes to write
        bne PrinterRead                 ; Branch to read the next byte of this entry if not 0
        
        jmp PrinterEntryLoop            ; Branch to read the next entry
exPrinter:
        
;        jsr RestoreBank
        
        ldy tempY
        ldx tempX
        lda temp00
        sta $00
        lda temp01
        sta $01
rts

addMessageToQueue:
    stx tempX
    ldx messageQueueOffset
    inx
    sta messageQueue,x
    stx messageQueueOffset
    ldx tempX
rts

handleMessageQueue:
    ldx messageQueueOffset
    beq exHandleMessageQueue

-
    lda messageQueue,x
    jsr Printer
    dex
    bne -
    stx messageQueueOffset
    
exHandleMessageQueue:
rts

